commit c492be629f06e3cf71fdf832ce2cd5ac1ec779f8
Author: Alex Zirbel <azirbel@andrew.cmu.edu>
Date:   Tue Jan 3 23:41:55 2012 -0500

    Updated the licensing information in many files.
    
    This is a broken commit because I decided to do this at a bad time. Sorry! The build will be working after next commit, I promise (and I won't push till then). This commit reflects the licensing in the files after I used my auto-add/remove script.

diff --git a/scout/scoutsim/src/scoutsim.cpp b/scout/scoutsim/src/scoutsim.cpp
index 10aac88..a8ee3f9 100644
--- a/scout/scoutsim/src/scoutsim.cpp
+++ b/scout/scoutsim/src/scoutsim.cpp
@@ -1,13 +1,48 @@
-/*
- * This package was developed by the CMU Robotics Club project using code
- * from Willow Garage, Inc.  Please see licensing.txt for details.
+/**
+ * The code in this package was developed using the structure of Willow
+ * Garage's turtlesim package.  It was modified by the CMU Robotics Club
+ * to be used as a simulator for the Colony Scout robot.
  *
+ * All redistribution of this code is limited to the terms of Willow Garage's
+ * licensing terms, as well as under permission from the CMU Robotics Club.
+ * 
+ * Copyright (c) 2011 Colony Project
+ * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * Copyright (c) 2009, Willow Garage, Inc.
  * All rights reserved.
- *
- * @brief Runs the simulator, keeping track of all the scout robots.
- * @file scoutsim.cpp
- * @author Colony Project, CMU Robotics Club
- * @author Alex Zirbel
+ * 
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ * 
+ *    Redistributions of source code must retain the above copyright
+ *       notice, this list of conditions and the following disclaimer.
+ *    Redistributions in binary form must reproduce the above copyright
+ *       notice, this list of conditions and the following disclaimer in the
+ *       documentation and/or other materials provided with the distribution.
+ *    Neither the name of the Willow Garage, Inc. nor the names of its
+ *       contributors may be used to endorse or promote products derived from
+ *       this software without specific prior written permission.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
  */
 
 #include <wx/app.h>
@@ -25,55 +60,54 @@
 
 class ScoutApp : public wxApp
 {
-public:
-  char** local_argv;
-  ros::NodeHandlePtr nh;
+    public:
+        char** local_argv;
+        ros::NodeHandlePtr nh;
 
-  ScoutApp()
-  {
-  }
+        ScoutApp()
+        {
+        }
 
-  bool OnInit()
-  {
+        bool OnInit()
+        {
 #ifdef __WXMAC__
-    ProcessSerialNumber PSN;
-    GetCurrentProcess(&PSN);
-    TransformProcessType(&PSN,kProcessTransformToForegroundApplication);
-    SetFrontProcess(&PSN);
+            ProcessSerialNumber PSN;
+            GetCurrentProcess(&PSN);
+            TransformProcessType(&PSN,kProcessTransformToForegroundApplication);
+            SetFrontProcess(&PSN);
 #endif
 
-    // create our own copy of argv, with regular char*s.
-    local_argv =  new char*[ argc ];
-    for ( int i = 0; i < argc; ++i )
-    {
-      local_argv[ i ] = strdup( wxString( argv[ i ] ).mb_str() );
-    }
+            // Create our own copy of argv, with regular char*s.
+            local_argv = new char*[ argc ];
+            for ( int i = 0; i < argc; ++i )
+            {
+                local_argv[ i ] = strdup( wxString( argv[ i ] ).mb_str() );
+            }
 
-    ros::init(argc, local_argv, "scoutsim");
-    nh.reset(new ros::NodeHandle);
+            ros::init(argc, local_argv, "scoutsim");
+            nh.reset(new ros::NodeHandle);
 
-    wxInitAllImageHandlers();
+            wxInitAllImageHandlers();
 
-    scoutsim::SimFrame* frame = new scoutsim::SimFrame(NULL);
+            scoutsim::SimFrame* frame = new scoutsim::SimFrame(NULL);
 
-    SetTopWindow(frame);
-    frame->Show();
+            SetTopWindow(frame);
+            frame->Show();
 
-    return true;
-  }
+            return true;
+        }
 
-  int OnExit()
-  {
-    for ( int i = 0; i < argc; ++i )
-    {
-      free( local_argv[ i ] );
-    }
-    delete [] local_argv;
+        int OnExit()
+        {
+            for ( int i = 0; i < argc; ++i )
+            {
+                free( local_argv[ i ] );
+            }
+            delete [] local_argv;
 
-    return 0;
-  }
+            return 0;
+        }
 };
 
 DECLARE_APP(ScoutApp);
 IMPLEMENT_APP(ScoutApp);
-